using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

using XNACS1Lib;

namespace ParticleDemo {
    public class Game1 : XNACS1Base {


        XNACS1Circle circleWithTail;
        
        XNACS1ParticleEmitter.TailEmitter controllableTail;
        XNACS1Circle tailHead;
        XNACS1ParticleEmitter.ExplodeEmitter controllableExplosion;

        XNACS1ParticleEmitter.ExplodeEmitter constantExplosion;
       


        double i = 0;

        protected override void InitializeWorld() {
            World.SetWorldCoordinate(Vector2.One, 100);
            World.SetWorldCoordinate(new Vector2(-World.WorldDimension.X / 2, -World.WorldDimension.Y / 2), 100);
            World.SetBackgroundColor(Color.Black);

            //controllabletail
            
            controllableTail = new XNACS1ParticleEmitter.TailEmitter(Vector2.Zero, 50, .5f, "Particle009", Color.Green);
            tailHead = new XNACS1Circle(Vector2.Zero, .6f, "Particle009");
            tailHead.TextureTintColor = Color.Green;
            controllableTail.AttachedPrimitive = tailHead;

            //explosion following tail (a button to explode)
            controllableExplosion = new XNACS1ParticleEmitter.ExplodeEmitter(Vector2.Zero,15, .4f, "Particle011", Color.OrangeRed, 3);
            controllableExplosion.AttachedPrimitive = controllableTail;

            //constant explosion
            constantExplosion = new XNACS1ParticleEmitter.ExplodeEmitter(new Vector2(-15,-15), 15, .4f, "Particle011", Color.OrangeRed, 3);

            //circle on path with tail
            XNACS1ParticleEmitter.TailEmitter tail = new XNACS1ParticleEmitter.TailEmitter(Vector2.One, 30, .5f, "Particle011", Color.LightBlue);
            circleWithTail = new XNACS1Circle(Vector2.Zero, 1);
            circleWithTail.CenterX = 8 * (float)Math.Sin(i);
            circleWithTail.CenterY = 8 * (float)Math.Cos(i);
            tail.AttachedPrimitive = circleWithTail;
            circleWithTail.Color = Color.Red;

            

            XNACS1Particle red = new XNACS1Particle(new Vector2(16, 16), 7, 0, "Particle011");
            red.TextureTintColor = new Color(255, 0, 0);
            XNACS1Particle green = new XNACS1Particle(new Vector2(21, 16), 7, 0, "Particle011");
            green.TextureTintColor = new Color(0, 255, 0);
            XNACS1Particle blue = new XNACS1Particle(new Vector2(19, 21), 7, 0, "Particle011");
            blue.TextureTintColor = new Color(0, 0, 255);

            

        }

        protected override void UpdateWorld() {
            if (GamePad.ButtonBackClicked())
                Exit();

            i += .05;

            circleWithTail.CenterX = 8*(float)Math.Sin(i);
            circleWithTail.CenterY = 8*(float)Math.Cos(i);

            tailHead.Center += GamePad.ThumbSticks.Right;

            if (GamePad.ButtonAClicked())
                controllableExplosion.Explode(100);
            constantExplosion.Explode(20);
        }
    }
}
